<%-- input_date_combo tag --%>
<%@ tag pageEncoding="UTF-8" body-content="empty"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/functions" prefix="fn" %>
<%@ taglib uri="http://www.jasminesoft.co.jp/jfc" prefix="jfc" %>
<%@ taglib tagdir="/WEB-INF/tags" prefix="tags" %>
<fmt:setBundle basename="jfcapp"/>

<%@ attribute name="value" required="true" type="java.lang.Object" %> <%-- ${TemplateModel_p.FDateCombo} --%>
<%@ attribute name="name" required="true" %> <%-- TemplateModel_p_002ff_date_combo --%>
<%@ attribute name="isReadonly" type="java.lang.Boolean" %>
<%@ attribute name="year_textfield" type="java.lang.Boolean" %>
<%@ attribute name="year_begin" %> <%-- 1990 --%>
<%@ attribute name="year_range" %> <%-- 10 --%>
<%@ attribute name="type" required="true" %> <%-- YMDHMS or YMDHM or YMDH or YMD or YM or Y --%>
<%@ attribute name="subformat" %> <%-- common.js formatDateObject function --%>
<%@ attribute name="rangetype" %> <%-- normal or begin or end or onerange --%>
<%@ attribute name="onerangeEndName" %>
<%@ attribute name="onerangeEndValue" type="java.lang.Object" %>
<%@ attribute name="nendoBeginMonth" type="java.lang.Integer" %> <%-- 1...12 --%>
<%@ attribute name="onchange" %>
<%@ attribute name="onkeydown" %>
<%@ attribute name="imeMode" %>
<%@ attribute name="isOutputFieldClass" type="java.lang.Boolean" %>
<%@ attribute name="fieldClassSuffix" %>
<%@ attribute name="selectinput_config" %>
<%@ attribute name="size" %> <%-- use only selectinput_config is input --%>
<%@ attribute name="maxlength" %> <%-- use only selectinput_config is input --%>
<%@ attribute name="valuetype" %> <%-- date or dateTime, default is date --%>
<%@ attribute name="isCalendarinput" type="java.lang.Boolean" %> <%-- use only selectinput_config is input --%>
<%@ attribute name="calendarinputDateFormat" %>
<%@ attribute name="calendarinputButtonType" %>
<%@ attribute name="calendarinputButtonTypeImageSrc" %>
<%@ attribute name="dateformat" %>
<%@ attribute name="timeSelectInput" %>
<%@ attribute name="tooltip" %>
<%@ attribute name="placeholder" %>
<%@ attribute name="cursorPosition" %>
<%@ attribute name="style" %>
<%@ attribute name="isRequired" type="java.lang.Boolean" %>
<%@ attribute name="tabIndex" %>
<%@ attribute name="enterKeyAction" %>

<%-- onkeydown variable --%>
<c:choose>
<c:when test="${enterKeyAction == 'changetab'}">
<c:set var="_onkeydown" value="if (event.keyCode !== 0x0d) return; enterKeyHandler.focusNextElement(this, event);"/>
</c:when>
<c:when test="${enterKeyAction == 'ignore'}">
<c:set var="_onkeydown" value="if (event.keyCode !== 0x0d) return; event.preventDefault();"/>
</c:when>
<c:when test="${enterKeyAction == 'default'}">
<c:set var="_onkeydown" value="if (event.keyCode !== 0x0d) return; doSubmitForm(event.srcElement.form);"/>
</c:when>
<c:otherwise>
<c:set var="_onkeydown" value="${enterKeyAction}"/>
</c:otherwise>
</c:choose>
<c:if test="${fn:length(_onkeydown) > 0}">
  <c:set var="onkeydown">${_onkeydown};${onkeydown}</c:set>
</c:if>

<c:choose>
<c:when test="${isReadonly}">
  <span id="content_${name}"><c:out value="${value.content}"/></span>
  <tags:show_text name="${name}" content="${value.content}" subformat="${subformat}"/>
</c:when>
<c:when test="${fn:startsWith(selectinput_config,'input')}">

<c:choose>
<c:when test="${fn:contains(dateformat, ' ')}">
<tags:input_dateTimeTextBox
    value="${value}"
    name="${name}"
    onchange="${onchange}"
    onkeydown="${onkeydown}"
    dateformat="${dateformat}"
	timeSelectInput="${timeSelectInput}"
    tooltip="${tooltip}"
    isRequired="${isRequired}"
    tabIndex="${tabIndex}"
    style="${style}"
    rangetype="${rangetype}"
/>
</c:when>
<c:otherwise>
<tags:input_date_combo_input
    value="${value}"
    name="${name}"
    isReadonly="${isReadonly}"
    year_textfield="${year_textfield}"
    year_begin="${year_begin}"
    year_range="${year_range}"
    type="${type}"
    subformat="${subformat}"
    rangetype="${rangetype}"
    onerangeEndName="${onerangeEndName}"
    onerangeEndValue="${onerangeEndValue}"
    nendoBeginMonth="${nendoBeginMonth}"
    onchange="${onchange}"
    onkeydown="${onkeydown}"
    imeMode="${imeMode}"
    isOutputFieldClass="${isOutputFieldClass}"
    fieldClassSuffix="${fieldClassSuffix}"
    selectinput_config="${selectinput_config}"
    size="${size}"
    style="${style}"
    maxlength="${maxlength}"
    valuetype="${valuetype}"
    isCalendarinput="${isCalendarinput}"
    calendarinputDateFormat="${calendarinputDateFormat}"
    calendarinputButtonType="${calendarinputButtonType}"
    calendarinputButtonTypeImageSrc="${calendarinputButtonTypeImageSrc}"
    dateformat="${dateformat}"
    tooltip="${tooltip}"
    placeholder="${placeholder}"
    cursorPosition="${cursorPosition}"
    isRequired="${isRequired}"
    tabIndex="${tabIndex}"
/>
</c:otherwise>
</c:choose>

<c:if test="${fn:length(subformat) > 0}">
  <tags:src_input_subformat
      value="${value}"
      name="${name}"
      subformat="${subformat}"/>
</c:if>
</c:when>
<c:otherwise>
<%-- not readonly --%>

<%-- __class variable --%>
<c:set var="__class" value=""/>
<c:choose>
<c:when test="${isOutputFieldClass}">
  <c:choose>
  <c:when test="${fn:length(value.errorcode) > 0}">
    <c:set var="__class" value="errorfield${fieldClassSuffix}"/>
  </c:when>
  <c:otherwise>
    <c:set var="__class" value="field${fieldClassSuffix}"/>
  </c:otherwise>
  </c:choose>
</c:when>
<c:otherwise>
  <c:if test="${fn:length(value.errorcode) > 0}">
    <c:set var="__class" value="errorfield_nowidth"/>
  </c:if>
</c:otherwise>
</c:choose>

<c:set var="__style" value=""/>
<c:if test="${fn:length(style) > 0}">
  <c:set var="__style" value="${style}"/>
</c:if>

<c:choose>
<c:when test="${year_textfield || fn:startsWith(selectinput_config,'text')}">
<c:set var="thisForm">this.textbox.form</c:set>
</c:when>
<c:otherwise>
<c:set var="thisForm">this.valueNode.form</c:set>
</c:otherwise>
</c:choose>
<c:set var="_onchange">expandDate_${name}(${thisForm})</c:set>
<c:if test="${fn:length(subformat) > 0}">
  <c:set var="_onchange">${_onchange};changeSubformatDisplay(dijit.byId('${name}'),'${name}__subformat','${subformat}')</c:set>
</c:if>
<c:set var="onchange">${_onchange};${onchange}</c:set>

<%-- nendoBeginMonth --%>
<c:if test="${nendoBeginMonth != null}">
  <c:choose>
  <c:when test="${nendoBeginMonth > 1}">
    <c:set var="nendoEndMonth">${nendoBeginMonth-1}</c:set>
  </c:when>
  <c:otherwise>
    <c:set var="nendoEndMonth">12</c:set>
  </c:otherwise>
  </c:choose>
</c:if>

<%-- year --%>
<c:choose>
<c:when test="${year_textfield || fn:startsWith(selectinput_config,'text')}">
<input data-dojo-type="dijit/form/ValidationTextBox" type="text" id="${name}_year" name="${name}_year" onchange="${onchange}" value="" size="6" maxlength="4" style="width: 4em;${__style}"
<c:if test="${fn:length(__class) > 0}"> class="${__class}"</c:if>
<c:if test="${isRequired}"> required="true"</c:if>
<c:if test="${fn:length(tabIndex) > 0}"> tabIndex="${tabIndex}"</c:if>
> <%-- input --%>
</c:when>
<c:otherwise>
<select data-dojo-type="wagby/Select" id="${name}_year" name="${name}_year" style="width: 5em;${__style}" onchange="${onchange}"
<c:if test="${fn:length(onkeydown) > 0}"> onKeyDown="${onkeydown}"</c:if>
<c:if test="${fn:length(__class) > 0}"> class="${__class}"</c:if>
<c:if test="${isRequired}"> required="true"</c:if>
<c:if test="${fn:length(tabIndex) > 0}"> tabIndex="${tabIndex}"</c:if>
> <%-- select --%>
<option value=" "></option>
<c:forEach var="__year" begin="${year_begin}" end="${year_begin + year_range}">
<option value="${__year}">
<c:out value="${__year}"/>
</option>
</c:forEach>
</select>
</c:otherwise>
</c:choose>
<c:choose>
<c:when test="${nendoBeginMonth != null}">
<span style="margin: 0 3px;"><fmt:message key="__jfc_common.yearnendo"/></span>
</c:when>
<c:otherwise>
<span style="margin: 0 3px;"><fmt:message key="__jfc_common.year"/></span>
</c:otherwise>
</c:choose>
<%-- month --%>
<c:if test="${type == 'YMDHMS' || type == 'YMDHM' || type == 'YMDH' || type == 'YMD' || type == 'YM'}">
<c:choose>
<c:when test="${fn:startsWith(selectinput_config,'text_ym')}">
<input data-dojo-type="dijit/form/ValidationTextBox" type="text" id="${name}_month" name="${name}_month" onchange="checkMonthValue_${name}(this.textbox.form);${onchange}" size="4" maxlength="2" style="width: 3em;${__style}"
<c:if test="${fn:length(__class) > 0}"> class="${__class}"</c:if>
<c:if test="${isRequired}"> required="true"</c:if>
<c:if test="${fn:length(tabIndex) > 0}"> tabIndex="${tabIndex}"</c:if>
> <%-- input --%>
</c:when>
<c:otherwise>
<select data-dojo-type="wagby/Select" id="${name}_month" name="${name}_month" style="width: 3em;${__style}" onchange="${onchange}"
<c:if test="${fn:length(onkeydown) > 0}"> onKeyDown="${onkeydown}"</c:if>
<c:if test="${fn:length(__class) > 0}"> class="${__class}"</c:if>
<c:if test="${isRequired}"> required="true"</c:if>
<c:if test="${fn:length(tabIndex) > 0}"> tabIndex="${tabIndex}"</c:if>
> <%-- select --%>
<option value=" "></option>
<c:choose>
<c:when test="${nendoBeginMonth != null}">
<c:forEach var="__month" begin="${nendoBeginMonth}" end="12">
<option value="${__month}"><c:out value="${__month}"/></option>
</c:forEach>
<c:if test="${nendoBeginMonth > 1}">
<c:forEach var="__month" begin="1" end="${nendoEndMonth}">
<option value="${__month}"><c:out value="${__month}"/></option>
</c:forEach>
</c:if>
</c:when>
<c:otherwise>
<c:forEach var="__month" begin="1" end="12">
<option value="${__month}"><c:out value="${__month}"/></option>
</c:forEach>
</c:otherwise>
</c:choose>
</select>
</c:otherwise>
</c:choose>
<span style="margin: 0 3px;"><fmt:message key="__jfc_common.month"/></span>
</c:if>
<%-- day --%>
<c:if test="${type == 'YMDHMS' || type == 'YMDHM' || type == 'YMDH' || type == 'YMD'}">
<c:choose>
<c:when test="${fn:startsWith(selectinput_config,'text_ymd')}">
<input data-dojo-type="dijit/form/ValidationTextBox" type="text" id="${name}_day" name="${name}_day" onchange="checkDayValue_${name}(form);${onchange}" size="4" maxlength="2" style="width: 3em;${__style}"
<c:if test="${fn:length(__class) > 0}"> class="${__class}"</c:if>
<c:if test="${isRequired}"> required="true"</c:if>
<c:if test="${fn:length(tabIndex) > 0}"> tabIndex="${tabIndex}"</c:if>
> <%-- input --%>
</c:when>
<c:otherwise>
<select data-dojo-type="wagby/Select" id="${name}_day" name="${name}_day" style="width: 3em;${__style}" onchange="${onchange}"
<c:if test="${fn:length(onkeydown) > 0}"> onKeyDown="${onkeydown}"</c:if>
<c:if test="${fn:length(__class) > 0}"> class="${__class}"</c:if>
<c:if test="${isRequired}"> required="true"</c:if>
<c:if test="${fn:length(tabIndex) > 0}"> tabIndex="${tabIndex}"</c:if>
> <%-- select --%>
<option value=" "></option>
<c:forEach var="__day" begin="1" end="31">
<option value="${__day}"><c:out value="${__day}"/></option>
</c:forEach>
</select>
</c:otherwise>
</c:choose>
<span style="margin: 0 3px;"><fmt:message key="__jfc_common.day"/></span>
</c:if>
<%-- hour --%>
<c:if test="${type == 'YMDHMS' || type == 'YMDHM' || type == 'YMDH'}">
<c:choose>
<c:when test="${fn:startsWith(selectinput_config,'text_ymdh')}">
<input data-dojo-type="dijit/form/ValidationTextBox" type="text" id="${name}_hour" name="${name}_hour" onchange="checkHourValue_${name}(form);${onchange}" size="4" maxlength="2" style="width: 3em;${__style}"
<c:if test="${fn:length(__class) > 0}"> class="${__class}"</c:if>
<c:if test="${isRequired}"> required="true"</c:if>
<c:if test="${fn:length(tabIndex) > 0}"> tabIndex="${tabIndex}"</c:if>
> <%-- input --%>
</c:when>
<c:otherwise>
<select data-dojo-type="wagby/Select" id="${name}_hour" name="${name}_hour" style="width: 3em;${__style}" onchange="${onchange}"
<c:if test="${fn:length(onkeydown) > 0}"> onKeyDown="${onkeydown}"</c:if>
<c:if test="${fn:length(__class) > 0}"> class="${__class}"</c:if>
<c:if test="${isRequired}"> required="true"</c:if>
<c:if test="${fn:length(tabIndex) > 0}"> tabIndex="${tabIndex}"</c:if>
> <%-- select --%>
<option value=" "></option>
<c:forEach var="__hour" begin="0" end="23">
<option value="${__hour}"><c:out value="${__hour}"/></option>
</c:forEach>
</select>
</c:otherwise>
</c:choose>
<span style="margin: 0 3px;"><fmt:message key="__jfc_common.hour"/></span>
</c:if>
<%-- minute --%>
<c:if test="${type == 'YMDHMS' || type == 'YMDHM'}">
<c:choose>
<c:when test="${fn:startsWith(selectinput_config,'text_ymdhm')}">
<input data-dojo-type="dijit/form/ValidationTextBox" type="text" id="${name}_minute" name="${name}_minute" onchange="checkMinuteValue_${name}(form);${onchange}" size="4" maxlength="2" style="width: 3em;${__style}"
<c:if test="${fn:length(__class) > 0}"> class="${__class}"</c:if>
<c:if test="${isRequired}"> required="true"</c:if>
<c:if test="${fn:length(tabIndex) > 0}"> tabIndex="${tabIndex}"</c:if>
> <%-- input --%>
</c:when>
<c:otherwise>
<select data-dojo-type="wagby/Select" id="${name}_minute" name="${name}_minute" style="width: 3em;${__style}" onchange="${onchange}"
<c:if test="${fn:length(onkeydown) > 0}"> onKeyDown="${onkeydown}"</c:if>
<c:if test="${fn:length(__class) > 0}"> class="${__class}"</c:if>
<c:if test="${isRequired}"> required="true"</c:if>
<c:if test="${fn:length(tabIndex) > 0}"> tabIndex="${tabIndex}"</c:if>
> <%-- select --%>
<option value=" "></option>
<c:forEach var="__minute" begin="0" end="59">
<option value="${__minute}"><c:out value="${__minute}"/></option>
</c:forEach>
</select>
</c:otherwise>
</c:choose>
<span style="margin: 0 3px;"><fmt:message key="__jfc_common.minute"/></span>
</c:if>
<%-- second --%>
<c:if test="${type == 'YMDHMS'}">
<c:choose>
<c:when test="${fn:startsWith(selectinput_config,'text_ymdhms')}">
<input data-dojo-type="dijit/form/ValidationTextBox" type="text" id="${name}_second" name="${name}_second" onchange="checkSecondValue_${name}(form);${onchange}" size="4" maxlength="2" style="width: 3em;${__style}"
<c:if test="${fn:length(__class) > 0}"> class="${__class}"</c:if>
<c:if test="${isRequired}"> required="true"</c:if>
<c:if test="${fn:length(tabIndex) > 0}"> tabIndex="${tabIndex}"</c:if>
> <%-- input --%>
</c:when>
<c:otherwise>
<select data-dojo-type="wagby/Select" id="${name}_second" name="${name}_second" style="width: 3em;${__style}" onchange="${onchange}"
<c:if test="${fn:length(onkeydown) > 0}"> onKeyDown="${onkeydown}"</c:if>
<c:if test="${fn:length(__class) > 0}"> class="${__class}"</c:if>
<c:if test="${isRequired}"> required="true"</c:if>
<c:if test="${fn:length(tabIndex) > 0}"> tabIndex="${tabIndex}"</c:if>
> <%-- select --%>
<option value=" "></option>
<c:forEach var="__second" begin="0" end="59">
<option value="${__second}"><c:out value="${__second}"/></option>
</c:forEach>
</select>
</c:otherwise>
</c:choose>
</c:if>

<tags:src_input_date_combo_notreadonly_javascript
    name="${name}"
    type="${type}" />

<tags:src_input_date_combo_javascript
    value="${value}"
    name="${name}"
    year_textfield="${year_textfield}"
    year_begin="${year_begin}"
    year_range="${year_range}"
    type="${type}"
    subformat="${subformat}"
    rangetype="${rangetype}"
    onerangeEndName="${onerangeEndName}"
    onerangeEndValue="${onerangeEndValue}"
    nendoBeginMonth="${nendoBeginMonth}"
    selectinput_config="${selectinput_config}"
    valuetype="${valuetype}"/>

<c:if test="${fn:length(subformat) > 0}">
  <tags:src_input_subformat
      value="${value}"
      name="${name}"
      subformat="${subformat}"/>
</c:if>
</c:otherwise>
</c:choose>
